/*!
* @file CreatureTrait.h
* @brief ゲーム中のクリーチャー特性のプロトタイプ
* @date 2013/12/22
* @author Deskull
* 2013 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"
#include "CreatureTemplate.h"

namespace Deeangband
{

	/*! 
	* @class CreatureTrait
	* @brief クリーチャー特性のクラス
	*/
	class CreatureTrait : public CreatureTemplate
	{
	private:

		NAME name;

		/*!
		* @brief クラスのシリアライズ化を設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param fileVersion ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int fileVersion) 
		{
			archive & BOOST_SERIALIZATION_NVP(name);
		}

	public:

		/*! 
		* @brief CreatureTraitクラスコンストラクタ(GameElementメンバ対応)
		* @param id GameElementのID
		* @param tag GameElementのタグ
		* @param gameWorld 所属元gameWorld参照ポインタ
		*/
		CreatureTrait::CreatureTrait(ID id, TAG tag, GameWorld *gameWorld);

		/*! 
		* @brief CreatureTraitクラスコンストラクタ
		*/
		CreatureTrait::CreatureTrait(void);

		/*! 
		* @brief CreatureTraitクラスデストラクタ
		*/
		CreatureTrait::~CreatureTrait(void);

		/*! 
		* @brief クリーチャー特性名を返す
		* @return クリーチャー特性名
		*/
		NAME CreatureTrait::GetName(void);

	};

}